/*
 *				**** DIR.C ****
 *
 * This file contains routines that read directories
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>

#include "prodlist.h"

ProdAlphaList *
list_files_in_directory(char *path)
{
	ProdAlphaList *ret=NULL;
	DIR *dirp;
	struct dirent *dirent;
	char *p;

	if ((dirp = opendir(path)) == NULL) return ret;

	if ((ret = create_alpha_prodlist(10)) == NULL) return NULL;

	while ((dirent = readdir(dirp)) != NULL)
	{ /* read through all directory entries */
		if (*dirent->d_name == '.') continue;	/* ignore dir/hidden files */
		p = strdup(dirent->d_name);
		insert_sorted_alpha_prodlist(ret, p);
	}

	closedir(dirp);
	return ret;
}
