/*
 *				**** UPDATE ALBUM FILES ****
 *
 * This file contains routines that will update
 * the changed album files.
 *
 * It does this by comparing the times of the various
 * input files with the time of the output file
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>

#include "prodlist.h"
#include "alblist.h"

static char *Prog = "upd_alb";

void
update_album_files(char *prog)
{
	int i, nalbs, updt;
   time_t old_time;
   struct album *alb;
   char buf[BUFSIZ];
   struct stat sbuf;

	Prog = prog;

   /*
    * loop thru all known albums and check for update
    */
   nalbs = get_number_albums();
   for (i=0; i < nalbs; i++)
   {
   	alb = get_album_by_key_loc(i); /* get next album */
      updt = 0; /* assume not updated */
      sprintf(buf, "discog/%s.html", alb->key);
      if (stat(buf, &sbuf)) old_time = 0L; /* no file */
      else old_time = sbuf.st_mtime;
      /* save modification time for comparing */
      old_time = sbuf.st_mtime;
      sprintf(buf, "alb/%s.html", alb->key);
		if (stat(buf, &sbuf) == 0)
      { /* file there - check date */
      	if (old_time < sbuf.st_mtime) updt++;
      } else continue; /* no input, no output */
      sprintf(buf, "tracks/%s.txt", alb->key);
      if (stat(buf, &sbuf) == 0)
      { /* file there - check time */
      	if (old_time < sbuf.st_mtime) updt++;
      }
      if (updt)
      {
      	printf("Album %s (%s) out of date.  Building ...\n",
         	alb->key, alb->title);
	      build_album(alb->key);
      }
   }
}

